# Copyright (c) Microsoft Corporation. 
# Licensed under the MIT License.

# File initially created using https://github.com/MIchaelMainer/policyservicetoolkit/blob/main/branch_protection_export.ps1.

name: msgraph-sdk-php-branch-protection
description: Branch protection policy for the msgraph-sdk-php repository
resource: repository
configuration:
  branchProtectionRules:

  - branchNamePattern: dev
    # This branch pattern applies to the following branches as of 08/30/2023:
    # dev

    # Specifies whether this branch can be deleted. boolean
    allowsDeletions: false
    # Specifies whether forced pushes are allowed on this branch. boolean
    allowsForcePushes: false
    # Specifies whether new commits pushed to the matching branches dismiss pull request review approvals. boolean
    dismissStaleReviews: true
    # Specifies whether admins can overwrite branch protection. boolean
    isAdminEnforced: false
    # Indicates whether "Require a pull request before merging" is enabled. boolean
    requiresPullRequestBeforeMerging: true
    # Specifies the number of pull request reviews before merging. int (0-6). Should be null/empty if PRs are not required
    requiredApprovingReviewsCount: 1
    # Require review from Code Owners. Requires requiredApprovingReviewsCount. boolean
    requireCodeOwnersReview: true
    # Are commits required to be signed. boolean. TODO: all contributors must have commit signing on local machines.
    requiresCommitSignatures: false
    # Are conversations required to be resolved before merging? boolean
    requiresConversationResolution: true
    # Are merge commits prohibited from being pushed to this branch. boolean
    requiresLinearHistory: false
    # Required status checks to pass before merging. Values can be any string, but if the value does not correspond to any existing status check, the status check will be stuck on pending for status since nothing exists to push an actual status
    requiredStatusChecks:
    #- validate-pull-request #TODO: add this back once we are using Kiota
    # Require branches to be up to date before merging. Requires requiredStatusChecks. boolean
    requiresStrictStatusChecks: true
    # Indicates whether there are restrictions on who can push. boolean. Should be set with whoCanPush.
    restrictsPushes: false
    # Restrict who can dismiss pull request reviews. boolean
    restrictsReviewDismissals: false

  - branchNamePattern: main
    # This branch pattern applies to the following branches as of 08/30/2023:
    # main

    # Specifies whether this branch can be deleted. boolean
    allowsDeletions: false
    # Specifies whether forced pushes are allowed on this branch. boolean
    allowsForcePushes: false
    # Specifies whether new commits pushed to the matching branches dismiss pull request review approvals. boolean
    dismissStaleReviews: true
    # Specifies whether admins can overwrite branch protection. boolean
    isAdminEnforced: false
    # Indicates whether "Require a pull request before merging" is enabled. boolean
    requiresPullRequestBeforeMerging: true
    # Specifies the number of pull request reviews before merging. int (0-6). Should be null/empty if PRs are not required
    requiredApprovingReviewsCount: 1
    # Require review from Code Owners. Requires requiredApprovingReviewsCount. boolean
    requireCodeOwnersReview: true
    # Are commits required to be signed. boolean. TODO: all contributors must have commit signing on local machines.
    requiresCommitSignatures: false
    # Are conversations required to be resolved before merging? boolean
    requiresConversationResolution: true
    # Are merge commits prohibited from being pushed to this branch. boolean
    requiresLinearHistory: false
    # Required status checks to pass before merging. Values can be any string, but if the value does not correspond to any existing status check, the status check will be stuck on pending for status since nothing exists to push an actual status
    requiredStatusChecks:
    #- validate-pull-request #TODO: add this back once we are using Kiota
    # Require branches to be up to date before merging. Requires requiredStatusChecks. boolean
    requiresStrictStatusChecks: true
    # Indicates whether there are restrictions on who can push. boolean. Should be set with whoCanPush.
    restrictsPushes: false
    # Restrict who can dismiss pull request reviews. boolean
    restrictsReviewDismissals: false

